<?xml version="1.0"  encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
  	extension-element-prefixes="redirect">


<xsl:template name="standard-analysis-package-design">
	<xsl:param name="reports-element"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="subsystem-name"/>
	<xsl:param name="single-package"/>
	<xsl:param name="package-element"/>

	<xsl:variable name="file-identifier">
   		<xsl:choose>
 			<xsl:when test="$single-package='true'">
		 		<xsl:value-of select="$package-element/@name"/>
			</xsl:when>
	        <xsl:otherwise>
	            <xsl:value-of select="$subsystem-name"/>
	        </xsl:otherwise>
        </xsl:choose>
   </xsl:variable>

	<xsl:variable name="catalog-identifier">
   		<xsl:choose>
 			<xsl:when test="$single-package='true'">
		 		<xsl:value-of select="'packages'"/>
			</xsl:when>
	        <xsl:otherwise>
	            <xsl:value-of select="'subsystems'"/>
	        </xsl:otherwise>
        </xsl:choose>
   </xsl:variable>

	<h3>Object Oriented Metrics :</h3>
	<p>See statics report for more. </p>
	<table class="details">
		<tr>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/dit-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	         </td>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/wmc-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	        </td>
		 </tr>
		<tr>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/cbo-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	         </td>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/ca-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	        </td>
		 </tr>
		 <tr>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/rfc-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	         </td>
			<td  style="background-color: white;">
		 		<div align="center">
	              <embed width="460" height="275" src="../img/lcom-image-{$file-identifier}.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
	            </div>
	        </td>
		 </tr>

	</table>



	<redirect:write file="{$docs-home}/img/wmc-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Methods per Class [WMC]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'wmc'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

	<redirect:write file="{$docs-home}/img/dit-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Depth of inheritance tree [DIT]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'dit'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

	<redirect:write file="{$docs-home}/img/cbo-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Efferent Class Couplings [CBO/Ce]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'cbo'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

	<redirect:write file="{$docs-home}/img/ca-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Afferent Class Couplings [Ca]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'ca'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

	<redirect:write file="{$docs-home}/img/lcom-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Lack of Cohesion [LCOM]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'lcom'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

	<redirect:write file="{$docs-home}/img/rfc-image-{$file-identifier}.svg">

        <xsl:call-template name="standard-dynamics-line-graph">
              <xsl:with-param name="text-y-axis" select="'Response for a Class [RFC]'"/>
              <xsl:with-param name="primary-metric-group" select="'oo-metrics'"/>
              <xsl:with-param name="primary-metric" select="'rfc'"/>
			  <xsl:with-param name="package-count-divisor" select="'true'"/>
              <xsl:with-param name="reports-element" select="$reports-element"/>
              <xsl:with-param name="packages-element" select="$packages-element"/>
              <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
              <xsl:with-param name="single-package" select="$single-package"/>
              <xsl:with-param name="package-element" select="$package-element"/>
        </xsl:call-template>

  	</redirect:write>

</xsl:template>



<xsl:template name="standard-analysis-package-design-details">
	<xsl:param name="reports-element"/>
	<xsl:param name="packages-element"/>
	<xsl:param name="subsystem-name"/>
	<xsl:param name="single-package"/>
	<xsl:param name="package-element"/>
	<html>
	<head>
         <link rel="stylesheet" type="text/css" href="../stylesheet.css"/>
	</head>
    <body>

	<table class="details">
		<tr><th>Version</th><th>Date</th><th>Packages</th><th>Total Abstract Classes</th><th>Total Concrete Classes</th><th>Total Afferent Couplings</th><th>Total Efferent Couplings</th><th>Mean Abstractness</th><th>Mean Instability</th><th>Mean Distance</th><th>Illegal Subsystems</th><th>Illegal Dependacies</th></tr>
		<xsl:for-each select="$reports-element/report">
			<xsl:sort select="@seq-id"/>
			<xsl:variable name="current-seq-id" select="@seq-id"/>
		   		<xsl:choose>
		 			<xsl:when test="$single-package='true'">
		 				<xsl:if test="$package-element/statistics/package-oo-metrics/distance/value[@seq-id=$current-seq-id]">
					 		<xsl:variable name="total-packages" select="count($package-element/package-availability/report[@seq-id=$current-seq-id])"/>
							<tr>
								<td><xsl:value-of select="version"/></td>
								<td><xsl:value-of select="date"/></td>
								<td><xsl:value-of select="$total-packages"/></td>
								<td><xsl:value-of select="$package-element/statistics/source-metrics/abstract-classes/value[@seq-id=$current-seq-id]/@value"/></td>
								<td><xsl:value-of select="$package-element/statistics/source-metrics/concrete-classes/value[@seq-id=$current-seq-id]/@value"/></td>
								<td><xsl:value-of select="$package-element/statistics/package-oo-metrics/afferent-coupling/value[@seq-id=$current-seq-id]/@value"/></td>
								<td><xsl:value-of select="$package-element/statistics/package-oo-metrics/efferent-coupling/value[@seq-id=$current-seq-id]/@value"/></td>
								<td><xsl:value-of select="format-number($package-element/statistics/package-oo-metrics/abstractness/value[@seq-id=$current-seq-id]/@value div $total-packages,'#.##')"/></td>
								<td><xsl:value-of select="format-number($package-element/statistics/package-oo-metrics/instability/value[@seq-id=$current-seq-id]/@value div $total-packages,'#.##')"/></td>
								<td><xsl:value-of select="format-number($package-element/statistics/package-oo-metrics/distance/value[@seq-id=$current-seq-id]/@value div $total-packages,'#.###')"/></td>
								<td><xsl:value-of select="count($package-element/statistics/dependancy-metrics/subsystem[@legal='false']/value[(@seq-id=$current-seq-id) and (@value &gt; 0)])"/></td>
								<td><xsl:value-of select="format-number(sum($package-element/statistics/dependancy-metrics/subsystem[@legal='false']/value[@seq-id=$current-seq-id]/@value),'#.##')"/></td>
							</tr>
						</xsl:if>
					</xsl:when>
			        <xsl:otherwise>
			            <xsl:if test="$packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/distance/value[@seq-id=$current-seq-id]">
				            <xsl:variable name="total-packages" select="count($packages-element/package[starts-with(@subsystem,$subsystem-name)]/package-availability/report[@seq-id=$current-seq-id])"/>
							<tr>
								<td><xsl:value-of select="version"/></td>
								<td><xsl:value-of select="date"/></td>
								<td><xsl:value-of select="$total-packages"/></td>
								<td><xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/source-metrics/abstract-classes/value[@seq-id=$current-seq-id]/@value)"/></td>
								<td><xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/source-metrics/concrete-classes/value[@seq-id=$current-seq-id]/@value)"/></td>
								<td><xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/afferent-coupling/value[@seq-id=$current-seq-id]/@value)"/></td>
								<td><xsl:value-of select="sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/efferent-coupling/value[@seq-id=$current-seq-id]/@value)"/></td>
								<td><xsl:value-of select="format-number(sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/abstractness/value[@seq-id=$current-seq-id]/@value) div $total-packages,'#.##')"/></td>
								<td><xsl:value-of select="format-number(sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/instability/value[@seq-id=$current-seq-id]/@value) div $total-packages,'#.##')"/></td>
								<td><xsl:value-of select="format-number(sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/package-oo-metrics/distance/value[@seq-id=$current-seq-id]/@value) div $total-packages,'#.##')"/></td>
								<td><xsl:value-of select="count($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/dependancy-metrics/subsystem[@legal='false']/value[(@seq-id=$current-seq-id) and (@value &gt; 0)])"/></td>
								<td><xsl:value-of select="format-number(sum($packages-element/package[starts-with(@subsystem,$subsystem-name)]/statistics/dependancy-metrics/subsystem[@legal='false']/value[@seq-id=$current-seq-id]/@value),'#.##')"/></td>
							</tr>
						</xsl:if>
			        </xsl:otherwise>
		        </xsl:choose>

		</xsl:for-each>
	</table>

	</body>
	</html>

</xsl:template>

</xsl:stylesheet>
