<?xml version="1.0" encoding="UTF-8"?> 
<!-- =======================================================================
 XRadar
 Copyright (c) 2008 David Stokar, AdNovum AG
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY UT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 See licence.txt for dependancies to other open projects. 
 ======================================================================= -->
 <xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
   
    
 <xsl:template match="Languages" mode="languages-used-analysis">	
    <html>
       <head>
           <link rel="stylesheet" type="text/css" href="stylesheet.css"/>
       </head>
       <body>
         <xsl:call-template name="page-header">
   	  		<xsl:with-param name="main-menu-page-name" select="'analysis'"/>
   	  		<xsl:with-param name="page-name" select="'languages used analysis'"/>
   	    </xsl:call-template>
   		  		
       	<p>  	
   		<b>Analyis Description:</b><br/>
                 <a href="http://cloc.sourceforge.net/">Cloc's</a> method of operation resembles SLOCCount's: First, create a list of files to consider. Next, attempt to determine whether or not found files contain recognized computer language source code. Finally, for files identified as source files, invoke language-specific routines to count the number of source lines.<br/>
   		Total languages used : <xsl:value-of select="count(language)"/> 
   		
   		</p>  		
   		<table width="100%" class="details">
 	        <tr>
 	          <th colspan="3">Language</th>	          
 	        </tr>	 	        
 	        <xsl:apply-templates select="language" mode="language-summary"/>	  		
       	</table>
   		<br/>
   		<table width="100%" class="details">
 	        <tr>
 	          <th>Language</th>
 	          <th>Files</th>
 	          <th>Code</th>
 	          <th>Blank</th>
 	          <th>Comment</th>
 	          <th>3rd Generation Factor</th>
 	          <th>3rd Generation Factor LoC</th>
 	        </tr>	        
 	        <xsl:apply-templates select="language" mode="language-list"/>		  			  					 
       	</table>
       		
       </body>
    </html>
 </xsl:template>
 
 <xsl:template match="language" mode="language-summary">   
 	<xsl:variable name="name" select="@name"/>	
 	<xsl:if test="position() mod 30 = 1">
 		<xsl:text disable-output-escaping="yes"><![CDATA[<tr>]]></xsl:text>
 	</xsl:if>
 	
     	<xsl:if test="position() mod 10 = 1">
     		<xsl:text disable-output-escaping="yes"><![CDATA[<td align="left" valign="top">]]></xsl:text>
     	</xsl:if>
 			<a>
 				<xsl:attribute name="href">#<xsl:value-of select="@name"/></xsl:attribute>
 				<xsl:value-of select="@name"/>
 			</a>
 <br/>
 		<xsl:if test="position() mod 10 = 0">
     		<xsl:text disable-output-escaping="yes"><![CDATA[</td>]]></xsl:text>
     	</xsl:if>
 	<xsl:if test="position() mod 30 = 0">
 	<xsl:text disable-output-escaping="yes"><![CDATA[</tr>]]></xsl:text>
 	</xsl:if>
 </xsl:template>
 
 <xsl:template match="language" mode="language-list">   
 	<xsl:variable name="name" select="@name"/>
 	<xsl:variable name="files" select="@files_count"/>
 	<xsl:variable name="code" select="@code"/>
 	<xsl:variable name="blank" select="@blank"/>
 	<xsl:variable name="comment" select="@comment"/>
 	<xsl:variable name="factor" select="@factor"/>
 	<xsl:variable name="scaled" select="@scaled"/>
   	<tr>
       <td valign="top" align="left">
       <b><a>
       <xsl:attribute name="name">
       	<xsl:value-of select="$name"/>
       </xsl:attribute>
       <xsl:value-of select="$name"/>
       </a></b>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="files">
       	<xsl:value-of select="$files"/>
       </xsl:attribute>
       <xsl:value-of select="$files"/>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="code">
       	<xsl:value-of select="$code"/>
       </xsl:attribute>
       <xsl:value-of select="$code"/>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="blank">
       	<xsl:value-of select="$blank"/>
       </xsl:attribute>
       <xsl:value-of select="$blank"/>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="comment">
       	<xsl:value-of select="$comment"/>
       </xsl:attribute>
       <xsl:value-of select="$comment"/>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="factor">
       	<xsl:value-of select="$factor"/>
       </xsl:attribute>
       <xsl:value-of select="$factor"/>
       </td>
       <td valign="top" align="left">
       <xsl:attribute name="scaled">
       	<xsl:value-of select="$scaled"/>
       </xsl:attribute>
       <xsl:value-of select="$scaled"/>
       </td>
     </tr>
 </xsl:template>   
 
 </xsl:stylesheet>
